# Sedna-examples
A directory to share Sedna examples and tutorials to  demonstrate Sedna can implement across edge-cloud collaborative training 
and collaborative inference capabilities.  

This repository is home to the following features of examples:
* [Joint Inference](#joint-inference)
* [Incremental Learning](#incremental-learning)
* [Federated Learning](#federated-learning)
* [Lifelong Learning](#lifelong-learning)
* [Shared Storage](#shared-storage)

### Joint Inference
Example: [Using Joint Inference Service in Helmet Detection Scenario](./joint_inference/helmet_detection_inference/README.md)

### Incremental Learning
Example: [Using Incremental Learning Job in Helmet Detection Scenario](./incremental_learning/helmet_detection/README.md)

### Federated Learning
Example: [Using Federated Learning Job in Surface Defect Detection Scenario](./federated_learning/surface_defect_detection/README.md)

### Lifelong Learning
Example: [Using Lifelong Learning Job in Thermal Comfort Prediction Scenario](./lifelong_learning/atcii/README.md)

### Shared Storage
| Support Protocols  |Support Features| Examples |Release|
| :-------------: | :-------------: |:-------------: | :-------------: |
| S3 |Incremental Learning| [Using Incremental Learning Job in Helmet Detection Scenario on S3](storage/s3/incremental_learning/README.md) | 0.3.1+|
| S3 |Joint Inference| [Using Joint Inference Service in Helmet Detection Scenario on S3](storage/s3/joint_inference/README.md) | 0.3.0+|


